#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include "netfd.h"

#define	DEF_ADDR	"192.168.1.23"
#define	DEF_PORT	"11618"

static void	echo(netfd_t *);

static void
echo(nfd)
	register netfd_t *	nfd;
{
  struct sockaddr 	cliaddr;
  socklen_t		clilen = sizeof(cliaddr);
  char			buf[BUFSIZ];
  ssize_t		n;

  memset(buf, 0, sizeof(buf));
  n = netfd_recvfrom(nfd, buf, sizeof(buf), 0, &cliaddr, &clilen, NETFD_NO_TIMEOUT);
  if (n > 0) {
    register int	i;

    fputs("DEBUG[echo] ", stderr);
    for (i = 0; i < n; i++) {
      fprintf(stderr, "%c", buf[i]);
    }
    fputs("\n", stderr);

    netfd_sendto(nfd, buf, (size_t)n, 0, &cliaddr, clilen, NETFD_NO_TIMEOUT);

    if (strncmp(buf, "quit", 4) == 0) {
      exit(0);
    }
  }
}

int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  if (netfd_init(0) == 0) {
    netfd_t *	nsd;

    nsd = netfd_udp_server(DEF_ADDR, DEF_PORT);
    if (nsd != NULL) {
      fprintf(stderr, "DEBUG: %s:%s\n", DEF_ADDR, DEF_PORT);
      netfd_read_event_add(nsd);
      netfd_dispatch(echo, false, -1);
      netfd_close(nsd);
    }
  }

  return 0;
}
